
/**************************************************************

File Name:		matrixbyvector.asm

Date Modified:  2/17/00	GGL	
				6/6/00	GGL	modified so that SIMD is enabled in
							matrixbyvector.asm instead of here
				6/7/00	GGL verified on 0.1 Si; doesn't work in 0.0
				9/19/04	JDT	Ported to VDSP++ 3.5

Description:	Program to call matrixbyvector.asm

**************************************************************/

#include    "def21364.h"
#define		N 10		/*number of columns*/
#define		M 8		/*number of rows*/
/* dimension constants */

.extern mxnxnx1;

.section/DM seg_dmda;
.ALIGN 2;	/* Assembler directive to align buffers to longword address space */
.VAR		mat_a[M*N]="mat_a.dat";	/* Matrix A, input array in row major order  */
.VAR		mat_c[M+1];	/* Matrix C, output array in row major order; the last value in the buffer is a dummy value */


.section/PM seg_pmda;
.ALIGN 2;	/* Assembler directive to align buffers to longword address space */
.VAR		mat_b[N]="mat_b.dat"; /* Matrix B, input array in row major order  */


/* PM interrupt vector code */
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;


/* program memory code */		
.section/PM seg_pmco;
start:	
/* modify values */
		m0=1;
		m1=2;
		m9=2;
/* buffers for input matricies (mat_a and mat_b) ouput matrix (mat_c) */
		b0=mat_a;	l0=@mat_a;
		b1=mat_c;	l1=0;
		b8=mat_b;	l8=@mat_b;
/* call function that multiplies the two matricies */		
		call mxnxnx1 (db);
/* number of rows */
		r15=M;
/* half the number of columns */
		r14=N/2;
	
/* Terminate and wait */
wait1:   jump wait1;
	
